import math

BRIGHT_COLOR=(0.7, 1, 0.7)
DIM_COLOR=(0.0, 0.55, 0.0)
FADE_TIME=0.4


def computeColor(initTime, timeNow):
    elapsedTime=timeNow-initTime
        
    if elapsedTime>FADE_TIME:
        return DIM_COLOR
    else:
        br,bg,bb=BRIGHT_COLOR
        dr,dg,db=DIM_COLOR

        fracSinceRaster=elapsedTime/FADE_TIME

        interpR=(dr-br)*fracSinceRaster+br
        interpG=(dg-bg)*fracSinceRaster+bg
        interpB=(db-bb)*fracSinceRaster+bb

        return (interpR, interpG, interpB)
                

def computePulseColor(pulse, pulseFreq):
    mod=math.fmod(pulse,2.0*pulseFreq)

    frac=mod/pulseFreq
    if frac>1:
        frac=2-frac

    br,bg,bb=BRIGHT_COLOR
    dr,dg,db=DIM_COLOR

    interpR=(dr-br)*frac+br
    interpG=(dg-bg)*frac+bg
    interpB=(db-bb)*frac+bb

    return (interpR, interpG, interpB)
    
