
import random


gPlayerList=[]
gCurPlayerIndex=0


class Player:
    def __init__(self, name, bIsHuman):
        self.isHuman=bIsHuman
        self.curPlanet=None
        self.scores={}
        self.finishedLevel=False
        self.name=name
        


def initPlayers(numHumans, numAI):
    global gPlayerList
    gPlayerList=[]

    for i in range(numHumans):
        playerName="Human %d"%(i+1)
        gPlayerList.append(Player(playerName,True))
    for i in range(numAI):
        playerName="CPU %d"%(i+1)
        gPlayerList.append(Player(playerName,False))

def addPlayer(name, isHuman):
    gPlayerList.append(Player(name, isHuman))

def newLevel(firstPlanet,levelNum):
    random.shuffle(gPlayerList)
    global gCurPlayerIndex
    gCurPlayerIndex=0

    for p in gPlayerList:
        p.finishedLevel=False
        p.curPlanet=firstPlanet
        p.scores[levelNum]=0
        
def nextPlayer():
    global gCurPlayerIndex

    lastPlayerIndex=gCurPlayerIndex
    
    while True:
        gCurPlayerIndex += 1
        gCurPlayerIndex %= len(gPlayerList)
        if not gPlayerList[gCurPlayerIndex].finishedLevel:
            return True
        if gCurPlayerIndex==lastPlayerIndex:
            #looped all the way around, and back to beginning
            return False

def getCurrentPlayer():
    return gPlayerList[gCurPlayerIndex]


def currentPlayerFinishedLevel():
    getCurrentPlayer().finishedLevel=True
        
    
def getCurrentPlanet():
    return getCurrentPlayer().curPlanet

def noHumansLeft():
    for p in gPlayerList:
        if (p.isHuman and
            (not p.finishedLevel)):
            return False
    return True
