import fsmMgr

import math
import random

from OpenGL.GL import *
from OpenGL.GLU import *
import pygame, pygame.image
from pygame.locals import *

import mouseInfo
import stateFlight
import statePower
import tutorialProgress
import playerMgr
import level1
import textDraw
import stateAim
import stateMainMenu

NUM_DISPLAYED=10

TITLE_SIZE=8
CLICK_MSG="Click To Continue."
CLICK_MSG_SIZE=4

SCORE_SIZE=5
SCORE_SPACE=24

class StateTotalScore(fsmMgr.State):
    def __init__(self, data):
        fsmMgr.State.__init__(self)

        self.clicked=False
        self.dialogTime=0.0

        self.scoreList=[]

    def init(self):
        levelNum=level1.thisLevel.level
        
        for p in playerMgr.gPlayerList:
            totalScore=0
            for levelIndex in p.scores:
                totalScore += p.scores[levelIndex]

            self.scoreList.append((totalScore,p.name))
        self.scoreList.sort()

        if len(self.scoreList)>16:
            self.scoreList=self.scoreList[:16]

    def update(self, dt):
        pass


    def handleMouseButton(self, bDown, buttonIndex):
        if bDown==True and buttonIndex==1:
            self.clicked=True

        if bDown==False and buttonIndex==1 and self.clicked:
            fsmMgr.popState()
        return True


    def draw(self):
        textDraw.drawCenteredString(400,550,
                                    (.25, 1, .25),
                                    TITLE_SIZE,
                                    "FINAL STANDINGS")

        y=500

        nameX=100
        scoreX=650
        
        textDraw.drawString(nameX,y,
                            (.25,1,.25),
                            SCORE_SIZE,
                            "NAME")
        textDraw.drawCenteredString(scoreX,y,
                                    (.25,1,.25),
                                    SCORE_SIZE,
                                    "TOTAL")

        y-=SCORE_SPACE*1.5



        for i,s in enumerate(self.scoreList):
            totalScore,name=s

            textDraw.drawString(nameX,y,
                                (.25,1,.25),
                                SCORE_SIZE,
                                name)
            textDraw.drawCenteredString(scoreX,y,
                                        (.25,1,.25),
                                        SCORE_SIZE,
                                        str(totalScore))

            y-=SCORE_SPACE


        textDraw.drawCenteredString(400,50,
                                    (.25, 1, .25),
                                    CLICK_MSG_SIZE,
                                    CLICK_MSG)
        
        
    def handleMouseButton(self, bDown, buttonIndex):
        #calibrate power next

        if bDown==True and buttonIndex==1:
            self.clicked=True
        if bDown==False and buttonIndex==1 and self.clicked:
            self.done()
        return True

    def handleKey(self, key, unicode):
        self.done()
        return True

    def done(self):
        fsmMgr.popAll()
        fsmMgr.pushState(stateMainMenu.StateMainMenu(None))
